summaryrefslogtreecommitdiffstats
path: root/tests/ts/kill
diff options
context:
space:
mode:
authorSami Kerola2014-04-09 22:43:56 +0200
committerSami Kerola2014-04-26 20:04:57 +0200
commit76bf54b8a44a56041b998c1d144e8f31af84660f (patch)
treec810438eab29e06410bf071b5931805607299612 /tests/ts/kill
parenttests: check kill is converting signals names correctly (diff)
downloadkernel-qcow2-util-linux-76bf54b8a44a56041b998c1d144e8f31af84660f.tar.gz
kernel-qcow2-util-linux-76bf54b8a44a56041b998c1d144e8f31af84660f.tar.xz
kernel-qcow2-util-linux-76bf54b8a44a56041b998c1d144e8f31af84660f.zip
tests: check various ways to specify kill signal
CC: Bernhard Voelker <mail@bernhard-voelker.de> Signed-off-by: Sami Kerola <kerolasa@iki.fi>
Diffstat (limited to 'tests/ts/kill')
-rwxr-xr-xtests/ts/kill/options77
1 files changed, 77 insertions, 0 deletions
diff --git a/tests/ts/kill/options b/tests/ts/kill/options
new file mode 100755
index 000000000..33a9b9b85
--- /dev/null
+++ b/tests/ts/kill/options
@@ -0,0 +1,77 @@
+#!/bin/bash
+
+# This file is part of util-linux.
+#
+# This file is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This file is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+TS_TOPDIR="${0%/*}/../.."
+TS_DESC="options"
+
+. "$TS_TOPDIR/functions.sh"
+ts_init "$*"
+
+ts_check_test_command "$TS_CMD_KILL"
+ts_check_test_command "$TS_HELPER_SIGRECEIVE"
+
+all_ok=true
+
+HELPER_SYMLINK="$TS_OUTDIR/$(mktemp -u XXXXXXXXXXXXXXX)"
+ln -s "$TS_HELPER_SIGRECEIVE" "$HELPER_SYMLINK"
+trap "rm -f $HELPER_SYMLINK" 0
+
+try_option()
+{
+ "$HELPER_SYMLINK" >> "$TS_OUTPUT" 2>&1 &
+ TEST_PID=$!
+ # test_sigreceive needs time to start up
+ up=0
+ for i in 0.01 0.1 1 1 1 1; do
+ awk 'BEGIN { retval=1 }
+ $1 ~ /^SigCgt/ {
+ lbyte = strtonum("0x" substr($2, 16, 16))
+ if (and(lbyte, 1)) {
+ retval=0
+ }
+ } END {
+ exit retval
+ }' /proc/$TEST_PID/status &&
+ up=1 &&
+ break
+ sleep $i
+ done
+ test $up = 1 || echo "$@ sigreceive helper did not start" >> "$TS_OUTPUT"
+ "$TS_CMD_KILL" "$@" $TEST_PID >> "$TS_OUTPUT" 2>&1
+ if [ $? -ne 0 ]; then
+ echo "kill $@ did not work" >> "$TS_OUTPUT"
+ all_ok=false
+ fi
+ wait $TEST_PID
+ if [ $? -ne 1 ]; then
+ echo "wait $TEST_PID for $@ did not work" >> "$TS_OUTPUT"
+ all_ok=false
+ fi
+}
+
+try_option -s 1
+try_option --signal 1
+try_option --signal HUP
+try_option --signal SIGHUP
+try_option -q HUP
+try_option --queue HUP
+try_option -1
+try_option -HUP
+try_option -SIGHUP
+
+if $all_ok; then
+ echo 'all ok' >> "$TS_OUTPUT"
+fi
+
+ts_finalize